/* =========================================================================

NAME: ScriptBoxSuite 1.0

AUTHOR: banIDit (bondura@list.ru)
DATE  : 29.08.2007 15:00

COMMENT:
Scfript create bookmarks for each page in the document and "subbookmarks" with information about boxes.

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */

app.addSubMenu ({cName: "ScriptBo&xSuite", cParent: "Tools", nPos: 0,});
app.addMenuItem({cName: "&BookmarkBox", cParent: "ScriptBo&xSuite", cExec: "BM_pages()"});
app.addMenuItem({cName: "&ShowMeBoxes", cParent: "ScriptBo&xSuite", cExec: "ShowMeBoxes()"});

function BM_pages() //  
{
var root = this.bookmarkRoot; //    ""  

try {
    for (var i = 0; i < this.numPages; i++)
       {	
		root.createChild("Page " + (i+1), "this.pageNum=" + i, i);
			var width = BoxWidth("Crop",i); 
			var height = BoxHeight("Crop",i);
		root.children[i].createChild("CropBox: " + width + " x " + height, "this.pageNum=" + i, 0);
		root.children[i].children[0].color = ["RGB",1,0,0];
			var width = BoxWidth("Bleed",i); 
			var height = BoxHeight("Bleed",i);
		root.children[i].createChild("BleedBox: " + width + " x " + height, "this.pageNum=" + i, 1);
		root.children[i].children[1].color = ["RGB",0,1,0];
			var width = BoxWidth("Art",i); 
			var height = BoxHeight("Art",i);
		root.children[i].createChild("ArtBox: "  + width + " x " + height, "this.pageNum=" + i, 2);
		root.children[i].children[2].color = ["RGB",1,0,1];
			var width = BoxWidth("Trim",i); 
			var height = BoxHeight("Trim",i);
		root.children[i].createChild("TrimBox: " + width + " x " + height, "this.pageNum=" + i, 3);
		root.children[i].children[3].color = ["RGB",0,0,1];
			var width = BoxWidth("BBox",i); 
			var height = BoxHeight("BBox",i);
		root.children[i].createChild("BoundingBox: " + width + " x " + height, "this.pageNum=" + i, 4);		
       }
	}
catch(e)
{
app.alert("Processing error: "+e)
}
}

function ShowMeBoxes() 
{
var myDocs = app.activeDocs;
		if (myDocs.length > 0)
		{
try
	{ 
		var CropWidth = BoxWidth("Crop",this.pageNum);
		var CropHeight = BoxHeight("Crop",this.pageNum);
		var BleedWidth = BoxWidth("Bleed",this.pageNum);
		var BleedHeight = BoxHeight("Bleed",this.pageNum);
		var ArtWidth = BoxWidth("Art",this.pageNum);
		var ArtHeight = BoxHeight("Art",this.pageNum);
		var TrimWidth = BoxWidth("Trim",this.pageNum);
		var TrimHeight = BoxHeight("Trim",this.pageNum);
		var BBoxWidth = BoxWidth("BBox",this.pageNum);
		var BBoxHeight = BoxHeight("BBox",this.pageNum);
		
		app.alert 
		({
		cMsg: "CropBox: " + CropWidth + " x " + CropHeight + " mm\nBleedBox: " + BleedWidth + " x " + BleedHeight + " mm\nArtBox: " + ArtWidth + " x " + ArtHeight + " mm\nTrimBox: " + 
TrimWidth + " x " + TrimHeight + " mm\nBoundingBox: " + BBoxWidth + " x " + BBoxHeight + " mm",   
		nIcon:3,
		nType:0,
		cTitle:"Page "+(this.pageNum+1)
		});
	}
catch(e)
	{
		app.alert("Processing error: "+e)
	}
}	
}	


//   #####            #####
BoxWidth = function(myBox,myPage){
	var myDoc = event.target;
	var aRect = myDoc.getPageBox(myBox,myPage);
		width = (aRect[2] - aRect[0])*0.35275;
		width = Math.decRound(width,1)
		return width;
	}

//   #####            #####
BoxHeight = function(myBox,myPage){
	var myDoc = event.target;
	var aRect = myDoc.getPageBox(myBox,myPage);
		height = (aRect[1] - aRect[3])*0.35275;
		height = Math.decRound(height,1)
		return height;
	}
//   #####     ,     ;)     #####
Math.decRound = function (myNum, myDecNum) {
     return Math.round (myNum * Math.pow(10, myDecNum) ) / Math.pow(10, myDecNum);
    }



